#include <stdio.h>
#include <stdlib.h>
#define ull unsigned long long

int N,Q;
int A[100005],L,R,K;
int **m;//[100005][100005];

int main()
{
    scanf("%d%d",&N,&Q);

    m=(int**)calloc(N,sizeof(int*));

    for(int i=0;i<N;i++)
    {
     m[i]=(int*)calloc(N,sizeof(int));
     scanf("%d",&A[i]);
    }

    for(int i=0;i<N;i++)
    {
        m[i][i]=A[i];
        for(int j=i+1;j<N;j++) m[i][j]=m[i][j-1] & A[j];
    }
    for(int i=0;i<Q;i++){
     scanf("%d%d",&L,&R);
     printf("%d\n",m[L-1][R-1]);
    }

    return 0;
}
/*
5 4
1 5 4 3 2
1 3
4 5
2 5
2 3
*/